1000 DIM G$(10),T$(5),U$(5)
1010 DIM X0$(60),X1$(60),X2$(60),X3$(60),X4$(60),X5$(60),X6$(60),X7$(60)
1020 E9=.000001 : T=50 : REM -- Small number & Tab location for responses
1030 P1=3.141592653500003# : P2=P1/180 : REM -- PI, Deg =>= Radians
1040 I=0 : REM -- Pass counter ( for DO WHILE .not. Quit loop )
1050  '
1060  ' -- Sign-on message and initialization
1070  X0$="--------------------------------------------------------"
1080  X1$="I                                                      I"
1090 X2$="I   Maidenhead Grid Square Utility Program = GRIDX     I"
1100 X3$="I   (C) 1984   Dr. Thomas A. Clark, W3IWI              I"
1110 X4$="I              6388 Guilford Road                      I"
1120 X5$="I              Clarksville, MD 21029                   I"
1130 X6$="I   Permission is granted for non-profit, amateur      I"
1140 X7$="I   usage providing credit is given to the author.     I"
1150 '    ------------------------------------- TAC  20 Feb 84 ---
1160 PRINT CHR$(26)
1170 '
1180 '   -- Loop to get station info
1190 PRINT "This program calculates Maidenhead Grid Square from data
1200 PRINT "supplied as requested in the program."
1210 PRINT : PRINT
1220  PRINT "In the following, enter West Longitude and Latitude in"
1230   PRINT "units of degrees and decimals" : PRINT
1240 I=I+1 : PRINT : REM -- Start of loop
1250  IF I > 1 THEN 1290
1260   PRINT "Coordinates of 'home' station:" : GOTO 1490
1270 '
1280  '   -- Get target station info
1290   PRINT "Target:  C=Coordinates, G=Grid, Q=Quit",TAB(T), : INPUT T$
1300    T$=LEFT$(T$,1) : IF T$="C" THEN 1480
1310     IF T$="c" THEN 1480
1320      IF T$="G" THEN 1390
1330       IF T$="g" THEN 1390
1340        IF T$="Q" THEN END
1350         IF T$="q" THEN PRINT CHR$(26) : END
1360          PRINT "INVALID ENTRY -- TRY AGAIN" : GOTO 1290
1370 '
1380 '  --Grid Square entry for target station
1390 PRINT "Enter Grid Square (Use Caps)",TAB(T), : INPUT G$
1400  GOSUB 2010 : IF L3=6 THEN 1420
1410   PRINT "Grid square was padded to middle of cell = ",TAB(T),G$
1420    GOSUB 2240 : GOSUB 2290
1430     PRINT "Coordinates: W.Longitude = ",TAB(T),W," Deg.W"
1440      PRINT "                Latitude = ",TAB(T),L," Deg."
1450       GOTO 1550
1460 '
1470 '   -- Coordinate entry for either home or target station
1480 PRINT "Coordinates of station # ",I," :"
1490  PRINT "West Longitude =", TAB(T), : INPUT W
1500   PRINT "     Latitude  =", TAB(T), : INPUT L
1510    GOSUB 1880 : PRINT "   Grid Square = ",TAB(T),G$
1520     IF I = 1 THEN 1610 : REM -- Exit to initialize "home" station
1530 '
1540 ' -- Calculate Azimuth and bearing to target station
1550 GOSUB 2390
1560  PRINT "Azimuth to target station = ",TAB(T),A," Deg."
1570   PRINT "                    Range = ",TAB(T),R,U$
1580    GOTO 1240
1590 '
1600 '  --Initialization for "home" station
1610 W5=W*P2 : L5=L*P2 : S5=SIN(L5) : C5=COS(L5) : REM -- Trigonometry
1620  PRINT
1630   PRINT "Do you want Ranges in Km, Miles or Nautical Miles ?"
1640    PRINT "     Enter K, M or N", TAB(T), : INPUT U$ : U$=LEFT$(U$,1)
1650 '
1660 '   --Constants defined as U are the mean radius of the earth
1670 IF U$="K" THEN 1700
1680  IF U$="k" THEN 1700
1690   GOTO 1710
1700    U$=" Km. " : U=6366.2 : GOTO 1240
1710 IF U$="M" THEN 1740
1720  IF U$="m" THEN 1740
1730   GOTO 1750
1740    U$=" Miles" : U=3956.09 : GOTO 1240
1750 IF U$="N" THEN 1780
1760  IF U$="n" THEN 1780
1770   PRINT "INVALID ENTRY -- TRY AGAIN" : GOTO 1630
1780    U$=" N.Mi." : U= 60/P2 : GOTO 1240
1790 '   ---------------------
1800 '   -- Subroutine to convert Longitude and Latitude to Grid Square
1810 '    Call with W=West Longitude (e.g. Chicago = +88 degrees)
1820 '    and L=Latitude (+ for Northern Hemisphere).
1830 '    The units for both W and L are degrees.
1840 '
1850 '    On Completion, the string G$ contains the "Maidenhead"
1860 '    Grid Square as a 6-character string.
1870 '
1880 W3=180-W : IF W3<0 THEN W3=W3+360
1890  W1=INT(W3/20+E9)
1900   W2=INT((W3-20*W1)/2+E9)+48 : W1=W1+65
1910    W3=INT(24*(W3/2-INT(W3/2)+E9))+65
1920     L1=INT((L+90)/10+E9) : L2=INT(L+90+E9-10*L1)
1930      L3=INT((L+90-10*L1-L2)*24+E9) : L1=L1+65 : L2=L2+48 : L3=L3+65
1940       G$=CHR$(W1)+CHR$(L1)+CHR$(W2)+CHR$(L2)+CHR$(W3)+CHR$(L3)
1950        RETURN
1960 ' ---------------------
1970 ' -- Subroutine to Pad Grid Square to middle of a cell if
1980 '    all 6 characters are not given. This routine also checks
1990 '    the validity of the square and kills program if not correct.
2000 '
2010 L3=LEN(G$) : IF L3>6 THEN 2190
2020  IF L3=6 THEN 2060
2030   IF L3 < 4 THEN 2050 ELSE G$=MID$(G$,1,4)+"LL"
2040    GOTO 2060
2050     IF L3 < 2 THEN 2190 ELSE G$=MID$(G$,1,2)+"55LL"
2060 IF LEFT$(G$,1) < "A" THEN 2190
2070  IF LEFT$(G$,1) > "R" THEN 2190
2080   IF MID$(G$,2,1) < "A" THEN 2190
2090    IF MID$(G$,2,1) > "S" THEN 2190
2100     IF MID$(G$,3,1) < "0" THEN 2190
2110      IF MID$(G$,3,1) > "9" THEN 2190
2120       IF MID$(G$,4,1) < "0" THEN 2190
2130        IF MID$(G$,4,1) > "9" THEN 2190
2140         IF MID$(G$,5,1) < "A" THEN 2190
2150          IF MID$(G$,5,1) > "X" THEN 2190
2160           IF MID$(G$,6,1) < "A" THEN 2190
2170            IF MID$(G$,6,1) > "X" THEN 2190
2180             RETURN
2190 PRINT " ***** INVALID GRID SQUARE = ",G$," ***** ABORTED *****"
2200 CLEAR : GOTO 1000
2210 ' -----------------------
2220 ' -- Subroutine to convert Grid Square=G$ to West Longitude=W
2230 '    with W returned in degrees and fractions
2240 W1=ASC(LEFT$(G$,1))-65 : W2=ASC(MID$(G$,3,1))-48 : W3=ASC(MID$(G$,5,1))-65
2250  W=180 -20*W1 -2*W2 -W3/12 -1/24 : IF W<0 THEN W=360+W
2260   RETURN
2270 '
2280 ' -- Subroutine to convert Grid Square=G$ to Latitude=L
2290 L1=ASC(MID$(G$,2,1))-65:L2=ASC(MID$(G$,4,1))-48:L3=ASC(MID$(G$,6,1))-65
2300  L=-90 +10*L1 +L2 +L3/24 +1/48
2310   RETURN
2320 ' -------------------
2330 '
2340 '    On entry, W and L are the second stations west longitude
2350 '    and Latitude. The first ("home") station should already have
2360 '    its coordinates available as
2370 '         S5=Sin(Latitude), C5=Cos(Latitude), W5=W.Long (radians)
2380 '
2390 W6=W*P2 : L6=L*P2 : S6=SIN(L6) : C6=COS(L6)
2400  C=S5*S6 + C5*C6*COS(W6-W5) : IF ABS(C)>1 THEN C=SGN(C)
2410   S=SQR(1-C*C) : X=ATN(S/C) : IF C<0 THEN X=X+P1
2420    R=U*X : IF S<>0 THEN 2440 ELSE A=0
2430     RETURN
2440 C1=(S6-S5*C)/(S*C5) : IF ABS(C1)>1 THEN C1=SGN(C1)
2450  S1=SQR(1-C1*C1) : A=ATN(S1/ABS(C1))/P2 : S3 = SIN(W5-W6)
2460   IF S3<0 THEN A=-A
2470    IF C1<0 THEN A=180-A
2480     IF A<0 THEN A=A+360
2490      IF A>360 THEN A=A-360
2500       RETURN
2510 END
